Commit d53f23fe authored by Sebastian Andrzej Siewior's avatar Sebastian Andrzej Siewior Committed by David S. Miller

selftests: hsr: Reorder the testsuite.

Move the code and group into functions so it will be easier to extend
the test to HSRv1 so that both versions are covered.

Move the ping/test part into do_complete_ping_test() and the interface
setup into setup_hsr_interfaces().
Signed-off-by: default avatarSebastian Andrzej Siewior <bigeasy@linutronix.de>
Signed-off-by: default avatarDavid S. Miller <davem@davemloft.net>
parent 5c3ce539
...@@ -41,61 +41,6 @@ cleanup() ...@@ -41,61 +41,6 @@ cleanup()
done done
} }
ip -Version > /dev/null 2>&1
if [ $? -ne 0 ];then
echo "SKIP: Could not run test without ip tool"
exit $ksft_skip
fi
trap cleanup EXIT
for i in "$ns1" "$ns2" "$ns3" ;do
ip netns add $i || exit $ksft_skip
ip -net $i link set lo up
done
echo "INFO: preparing interfaces."
# Three HSR nodes. Each node has one link to each of its neighbour, two links in total.
#
# ns1eth1 ----- ns2eth1
# hsr1 hsr2
# ns1eth2 ns2eth2
# | |
# ns3eth1 ns3eth2
# \ /
# hsr3
#
# Interfaces
ip link add ns1eth1 netns "$ns1" type veth peer name ns2eth1 netns "$ns2"
ip link add ns1eth2 netns "$ns1" type veth peer name ns3eth1 netns "$ns3"
ip link add ns3eth2 netns "$ns3" type veth peer name ns2eth2 netns "$ns2"
# HSRv0.
ip -net "$ns1" link add name hsr1 type hsr slave1 ns1eth1 slave2 ns1eth2 supervision 45 version 0 proto 0
ip -net "$ns2" link add name hsr2 type hsr slave1 ns2eth1 slave2 ns2eth2 supervision 45 version 0 proto 0
ip -net "$ns3" link add name hsr3 type hsr slave1 ns3eth1 slave2 ns3eth2 supervision 45 version 0 proto 0
# IP for HSR
ip -net "$ns1" addr add 100.64.0.1/24 dev hsr1
ip -net "$ns1" addr add dead:beef:1::1/64 dev hsr1 nodad
ip -net "$ns2" addr add 100.64.0.2/24 dev hsr2
ip -net "$ns2" addr add dead:beef:1::2/64 dev hsr2 nodad
ip -net "$ns3" addr add 100.64.0.3/24 dev hsr3
ip -net "$ns3" addr add dead:beef:1::3/64 dev hsr3 nodad
# All Links up
ip -net "$ns1" link set ns1eth1 up
ip -net "$ns1" link set ns1eth2 up
ip -net "$ns1" link set hsr1 up
ip -net "$ns2" link set ns2eth1 up
ip -net "$ns2" link set ns2eth2 up
ip -net "$ns2" link set hsr2 up
ip -net "$ns3" link set ns3eth1 up
ip -net "$ns3" link set ns3eth2 up
ip -net "$ns3" link set hsr3 up
# $1: IP address # $1: IP address
is_v6() is_v6()
{ {
...@@ -164,93 +109,157 @@ stop_if_error() ...@@ -164,93 +109,157 @@ stop_if_error()
fi fi
} }
do_complete_ping_test()
echo "INFO: Initial validation ping." {
# Each node has to be able each one. echo "INFO: Initial validation ping."
do_ping "$ns1" 100.64.0.2 # Each node has to be able each one.
do_ping "$ns2" 100.64.0.1 do_ping "$ns1" 100.64.0.2
do_ping "$ns3" 100.64.0.1 do_ping "$ns2" 100.64.0.1
stop_if_error "Initial validation failed." do_ping "$ns3" 100.64.0.1
stop_if_error "Initial validation failed."
do_ping "$ns1" 100.64.0.3
do_ping "$ns2" 100.64.0.3 do_ping "$ns1" 100.64.0.3
do_ping "$ns3" 100.64.0.2 do_ping "$ns2" 100.64.0.3
do_ping "$ns3" 100.64.0.2
do_ping "$ns1" dead:beef:1::2
do_ping "$ns1" dead:beef:1::3 do_ping "$ns1" dead:beef:1::2
do_ping "$ns2" dead:beef:1::1 do_ping "$ns1" dead:beef:1::3
do_ping "$ns2" dead:beef:1::2 do_ping "$ns2" dead:beef:1::1
do_ping "$ns3" dead:beef:1::1 do_ping "$ns2" dead:beef:1::2
do_ping "$ns3" dead:beef:1::2 do_ping "$ns3" dead:beef:1::1
do_ping "$ns3" dead:beef:1::2
stop_if_error "Initial validation failed."
stop_if_error "Initial validation failed."
# Wait until supervisor all supervision frames have been processed and the node # Wait until supervisor all supervision frames have been processed and the node
# entries have been merged. Otherwise duplicate frames will be observed which is # entries have been merged. Otherwise duplicate frames will be observed which is
# valid at this stage. # valid at this stage.
WAIT=5 WAIT=5
while [ ${WAIT} -gt 0 ] while [ ${WAIT} -gt 0 ]
do do
grep 00:00:00:00:00:00 /sys/kernel/debug/hsr/hsr*/node_table grep 00:00:00:00:00:00 /sys/kernel/debug/hsr/hsr*/node_table
if [ $? -ne 0 ] if [ $? -ne 0 ]
then then
break break
fi fi
sleep 1 sleep 1
let "WAIT = WAIT - 1" let "WAIT = WAIT - 1"
done done
# Just a safety delay in case the above check didn't handle it. # Just a safety delay in case the above check didn't handle it.
sleep 1 sleep 1
echo "INFO: Longer ping test."
do_ping_long "$ns1" 100.64.0.2
do_ping_long "$ns1" dead:beef:1::2
do_ping_long "$ns1" 100.64.0.3
do_ping_long "$ns1" dead:beef:1::3
stop_if_error "Longer ping test failed."
do_ping_long "$ns2" 100.64.0.1
do_ping_long "$ns2" dead:beef:1::1
do_ping_long "$ns2" 100.64.0.3
do_ping_long "$ns2" dead:beef:1::2
stop_if_error "Longer ping test failed."
do_ping_long "$ns3" 100.64.0.1
do_ping_long "$ns3" dead:beef:1::1
do_ping_long "$ns3" 100.64.0.2
do_ping_long "$ns3" dead:beef:1::2
stop_if_error "Longer ping test failed."
echo "INFO: Cutting one link."
do_ping_long "$ns1" 100.64.0.3 &
echo "INFO: Longer ping test." sleep 3
do_ping_long "$ns1" 100.64.0.2 ip -net "$ns3" link set ns3eth1 down
do_ping_long "$ns1" dead:beef:1::2 wait
do_ping_long "$ns1" 100.64.0.3
do_ping_long "$ns1" dead:beef:1::3
stop_if_error "Longer ping test failed." ip -net "$ns3" link set ns3eth1 up
do_ping_long "$ns2" 100.64.0.1 stop_if_error "Failed with one link down."
do_ping_long "$ns2" dead:beef:1::1
do_ping_long "$ns2" 100.64.0.3
do_ping_long "$ns2" dead:beef:1::2
stop_if_error "Longer ping test failed."
do_ping_long "$ns3" 100.64.0.1 echo "INFO: Delay the link and drop a few packages."
do_ping_long "$ns3" dead:beef:1::1 tc -net "$ns3" qdisc add dev ns3eth1 root netem delay 50ms
do_ping_long "$ns3" 100.64.0.2 tc -net "$ns2" qdisc add dev ns2eth1 root netem delay 5ms loss 25%
do_ping_long "$ns3" dead:beef:1::2
stop_if_error "Longer ping test failed."
echo "INFO: Cutting one link." do_ping_long "$ns1" 100.64.0.2
do_ping_long "$ns1" 100.64.0.3 & do_ping_long "$ns1" 100.64.0.3
sleep 3 stop_if_error "Failed with delay and packetloss."
ip -net "$ns3" link set ns3eth1 down
wait
ip -net "$ns3" link set ns3eth1 up do_ping_long "$ns2" 100.64.0.1
do_ping_long "$ns2" 100.64.0.3
stop_if_error "Failed with one link down." stop_if_error "Failed with delay and packetloss."
echo "INFO: Delay the link and drop a few packages." do_ping_long "$ns3" 100.64.0.1
tc -net "$ns3" qdisc add dev ns3eth1 root netem delay 50ms do_ping_long "$ns3" 100.64.0.2
tc -net "$ns2" qdisc add dev ns2eth1 root netem delay 5ms loss 25% stop_if_error "Failed with delay and packetloss."
do_ping_long "$ns1" 100.64.0.2 echo "INFO: All good."
do_ping_long "$ns1" 100.64.0.3 }
setup_hsr_interfaces()
{
echo "INFO: preparing interfaces."
# Three HSR nodes. Each node has one link to each of its neighbour, two links in total.
#
# ns1eth1 ----- ns2eth1
# hsr1 hsr2
# ns1eth2 ns2eth2
# | |
# ns3eth1 ns3eth2
# \ /
# hsr3
#
# Interfaces
ip link add ns1eth1 netns "$ns1" type veth peer name ns2eth1 netns "$ns2"
ip link add ns1eth2 netns "$ns1" type veth peer name ns3eth1 netns "$ns3"
ip link add ns3eth2 netns "$ns3" type veth peer name ns2eth2 netns "$ns2"
# HSRv0.
ip -net "$ns1" link add name hsr1 type hsr slave1 ns1eth1 slave2 ns1eth2 supervision 45 version 0 proto 0
ip -net "$ns2" link add name hsr2 type hsr slave1 ns2eth1 slave2 ns2eth2 supervision 45 version 0 proto 0
ip -net "$ns3" link add name hsr3 type hsr slave1 ns3eth1 slave2 ns3eth2 supervision 45 version 0 proto 0
# IP for HSR
ip -net "$ns1" addr add 100.64.0.1/24 dev hsr1
ip -net "$ns1" addr add dead:beef:1::1/64 dev hsr1 nodad
ip -net "$ns2" addr add 100.64.0.2/24 dev hsr2
ip -net "$ns2" addr add dead:beef:1::2/64 dev hsr2 nodad
ip -net "$ns3" addr add 100.64.0.3/24 dev hsr3
ip -net "$ns3" addr add dead:beef:1::3/64 dev hsr3 nodad
# All Links up
ip -net "$ns1" link set ns1eth1 up
ip -net "$ns1" link set ns1eth2 up
ip -net "$ns1" link set hsr1 up
ip -net "$ns2" link set ns2eth1 up
ip -net "$ns2" link set ns2eth2 up
ip -net "$ns2" link set hsr2 up
ip -net "$ns3" link set ns3eth1 up
ip -net "$ns3" link set ns3eth2 up
ip -net "$ns3" link set hsr3 up
}
stop_if_error "Failed with delay and packetloss." ip -Version > /dev/null 2>&1
if [ $? -ne 0 ];then
echo "SKIP: Could not run test without ip tool"
exit $ksft_skip
fi
do_ping_long "$ns2" 100.64.0.1 trap cleanup EXIT
do_ping_long "$ns2" 100.64.0.3
stop_if_error "Failed with delay and packetloss." for i in "$ns1" "$ns2" "$ns3" ;do
ip netns add $i || exit $ksft_skip
ip -net $i link set lo up
done
do_ping_long "$ns3" 100.64.0.1 setup_hsr_interfaces
do_ping_long "$ns3" 100.64.0.2 do_complete_ping_test
stop_if_error "Failed with delay and packetloss."
echo "INFO: All good."
exit $ret exit $ret
Markdown is supported
0%
or
You are about to add 0 people to the discussion. Proceed with caution.
Finish editing this message first!
Please register or to comment